<script lang="ts">
  import { Table, Column } from 'sveltestrap';
  import { onMount } from 'svelte';
  import { BonusPointsWithTeamQuery } from '@models/BonusPoints.ts';
  import type { BonusPointsReturn, BonusPoints } from '@models/BonusPoints.ts';
  import { Gql } from '../../db';

  let bonusPoints: Array<BonusPoints> | null = null;

  onMount(() => {
    const sink = {
      // todo show a notification or something
      complete: () => console.warn('subscription is complete, page will no longer reload'),
      error: (err) => console.error(err),
      next: (res: { data: BonusPointsReturn }) => {
        bonusPoints = res.data.other_points;
      },
    };
    // todo hardcoded admin query here maybe isn't the best?
    Gql.subscribe(`subscription ${BonusPointsWithTeamQuery}`, sink, {
      role: 'admin',
    });
  });
</script>

<h6>All other points awarded</h6>

{#if bonusPoints}
  <Table rows={bonusPoints} let:row>
    <Column header="Team ID" width="8rem">
      {row.team_id}
    </Column>
    <Column header="Team name" width="8rem">
      {row.team ? row.team.name : ''}
    </Column>
    <Column header="Points" width="8rem">
      {row.points}
    </Column>
    <Column header="Reason">
      {row.reason}
    </Column>
    <Column header="Created At">
      {row.created_at}
    </Column>
  </Table>
{:else}
  <h4>...No other points awarded, yet</h4>
{/if}
